/*	
 *	framds11.c
 *
 *	RAM]FXLC`֐iyrEeNX`Ȃj
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2003 Naoyuki Sawa
 *
 *	* Tue Apr  2 05:53:00 JST 2003 Naoyuki Sawa
 *	- cliprend.cړĂ܂B
 */
#include "clip.h"

/*****************************************************************************
 *	
 *****************************************************************************/

#ifdef REND_NOASM
void
draw_scanline_wz_color(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param)
{
	unsigned char* vptr;	/* J[obt@|C^     */
	unsigned char* zptr;	/* yobt@|C^         */
	int nx;			/* ݂̃XLC̒ */
	int n;			/* ݂̕ӂ̎csNZ   */
	RENDVERTEX cur;		/* ݒl                     */
	DDA z;			/* ylDDA                    */
	const RENDVERTEX* tmp;
	int ofs;
	unsigned char zval;

	/* m :v0 -> v1:E Ƃ܂B */
	if(v0->x > v1->x) {
		tmp = v0;
		      v0 = v1;
		           v1 = tmp;
	}

	/* n_AhX߂܂B */
	ofs = param->surface_w * v0->y + v0->x;
	vptr = param->surface_vbuff + ofs;
	zptr = param->surface_zbuff + ofs;

	/* 厲DDAZbgAbvB */
	nx = v1->x - v0->x;
	if(nx == 0) return; /* _Ȃ`܂B */

	/* DDAZbgAbvB */
	SETUP2(z);

	/* DDA[vB */
	n = nx;
	do {
		/* yrB */
		zval = (unsigned char)(cur.z >> 8);
		if(zval <= *zptr) {
			/* eNX`ȂAtFCX̔wiFŕ`܂B */
			*vptr = param->back_color;
			*zptr = zval;
		}
		/* obt@|C^i߂܂B */
		vptr++;
		zptr++;
		/* DDAXebvsB */
		STEP2(z);
	} while(--n); /* E[sNZ͕`Ȃ̂ŁAvfNgłB */
}
#else /*REND_NOASM*/
#if 0
//	asm("
//	.code
//	.align 1
//	.global draw_scanline_wz_color
//	;// IN:
//	;// %r12     = v0
//	;// %r13     = v1
//	;// %r14     = param
//draw_scanline_wz_color:
//	;// USAGE:
//	;// %r0      = cur.z
//	;// %r1      = cur.s (gȂ)
//	;// %r2      = cur.t (gȂ)
//	;// [%sp+ 0] = DDA.z
//	;// [%sp+16] = DDA.s (gȂ)
//	;// [%sp+32] = DDA.t (gȂ)
//	pushn %r2
//	xsub %sp, %sp, 48
//
//	;// m :v0 -> v1:E Ƃ܂B
//	xld.uh %r4, [%r12+0]	;// v0->x
//	xld.uh %r5, [%r13+0]	;// v1->x
//	cmp %r4, %r5
//	xjrule __draw_scanline_wz_color_swap
//	xor %r12, %r13
//	xor %r13, %r12
//	xor %r12, %r13
//__draw_scanline_wz_color_swap:
//	;// %r12 = v0
//	;// %r13 = v1
//
//	;// n_AhX߂܂B
//	xld.uh %r4, [%r14+0]	;// param->surface_w
//	xld.uh %r5, [%r12+2]	;// v0->y
//	mltu.h %r4, %r5
//	ld.w %r4, %alr
//	xld.uh %r5, [%r12+0]	;// v0->x
//	add %r4, %r5
//	xld.w %r10, [%r14+4]	;// param->surface_vbuff
//	add %r10, %r4
//	xld.w %r11, [%r14+8]	;// param->surface_zbuff
//	add %r11, %r4
//	;// %r10 = vptr
//	;// %r11 = zptr
//	;// %r5  = v0->x
//
//	;// 厲DDAZbgAbvB
//	xld.uh %r15, [%r13+0]	;// v1->x
//	sub %r15, %r5
//	xjreq __draw_scanline_wz_color_ret
//	;// %r15 = nx
//
//	;// DDAZbgAbvB
//	;// (DDA.z)
//	xld.uh %r0, [%r12+4]	;// v0->z => cur.z
//	xld.uh %r4, [%r13+4]	;// v1->z
//	sub %r4, %r0
//	xld.w %r5, 1
//	xjruge __draw_scanline_wz_color_setup_z
//	not %r4, %r4
//	xadd %r4, %r4, 1
//	xld.w %r5, -1
//__draw_scanline_wz_color_setup_z:
//	xsll %r4, 16
//	ld.w %alr, %r4
//	div0u %r15
//	div1 %r15		;//  1
//	div1 %r15		;//  2
//	div1 %r15		;//  3
//	div1 %r15		;//  4
//	div1 %r15		;//  5
//	div1 %r15		;//  6
//	div1 %r15		;//  7
//	div1 %r15		;//  8
//	div1 %r15		;//  9
//	div1 %r15		;// 10
//	div1 %r15		;// 11
//	div1 %r15		;// 12
//	div1 %r15		;// 13
//	div1 %r15		;// 14
//	div1 %r15		;// 15
//	div1 %r15		;// 16
//	ld.w %r4, %ahr
//	add %r4, %r4
//	xld.w [%sp+ 0], %r4	;// z.n * 2
//	not %r4, %r15
//	xadd %r4, %r4, 1
//	xld.w [%sp+ 4], %r4	;// z.d
//	ld.w %r4, %alr
//	mlt.h %r4, %r5
//	ld.w %r4, %alr
//	xld.w [%sp+ 8], %r4	;// z.u
//	xld.w [%sp+12], %r5	;// z.v
//	;// %r0      = cur.z
//	;// [%sp+ 0] = z.n * 2
//	;// [%sp+ 4] = z.d
//	;// [%sp+ 8] = z.u
//	;// [%sp+12] = z.v
//
//	;// DDA[vB
//	ld.w %r7, %r15
//	add %r15, %r15
//	xld.ub %r12, [%r14+24]	;// param->back_color
//__draw_scanline_wz_color_loop:
//	;// %r7  = n
//	;// %r15 = nx * 2
//	;// %r12 = back_color
//
//	;// yrB
//	ld.uh %r4, %r0		;// zval
//	xsrl %r4, 8
//	xld.ub %r5, [%r11]	;// *zptr
//	cmp %r4, %r5
//	xjrugt __draw_scanline_wz_color_skip
//	;// %r4 = zval
//
//	;// eNX`ȂAtFCX̔wiFŕ`܂B
//	xld.b [%r10], %r12	;// *vptr
//	xld.b [%r11], %r4	;// *zptr
//__draw_scanline_wz_color_skip:
//
//	;// obt@|C^i߂܂B
//	xadd %r10, %r10, 1
//	xadd %r11, %r11, 1
//
//	;// DDAXebvsB
//	;// (DDA.z)
//	xld.w %r4, [%sp+ 8]	;// z.u
//	add %r0, %r4
//	xld.w %r4, [%sp+ 4]	;// z.d
//	xld.w %r5, [%sp+ 0]	;// z.n * 2
//	add %r4, %r5
//	xjruge __draw_scanline_wz_color_step_z ;// !C
//	xld.w %r5, [%sp+12]	;// z.v
//	add %r0, %r5
//	sub %r4, %r15
//__draw_scanline_wz_color_step_z:
//	xld.w [%sp+ 4], %r4	;// z.d
//
//	xsub %r7, %r7, 1
//	xjrne __draw_scanline_wz_color_loop
//
//__draw_scanline_wz_color_ret:
//	xadd	%sp, %sp, 48
//	popn	%r2
//	ret
//	");
#else	/* draw_scanline_wz_2bitmaskƓWX^蓖ẮAWIȎ */
	/* ]WX^Ƀ[N蓖ĂŁBWł30%x */
	asm("
	.code
	.align 1
	.global draw_scanline_wz_color
	;// IN:
	;// %r12     = v0
	;// %r13     = v1
	;// %r14     = param
draw_scanline_wz_color:
	;// USAGE:
	;// %r0  = cur.z
	;// %r1  = DDA.z.n * 2
	;// %r2  = DDA.z.d
	;// %r6  = DDA.z.u
	;// %r13 = DDA.z.v
	pushn %r2

	;// m :v0 -> v1:E Ƃ܂B
	xld.uh %r4, [%r12+0]	;// v0->x
	xld.uh %r5, [%r13+0]	;// v1->x
	cmp %r4, %r5
	xjrule __draw_scanline_wz_color_swap
	xor %r12, %r13
	xor %r13, %r12
	xor %r12, %r13
__draw_scanline_wz_color_swap:
	;// %r12 = v0
	;// %r13 = v1

	;// n_AhX߂܂B
	xld.uh %r4, [%r14+0]	;// param->surface_w
	xld.uh %r5, [%r12+2]	;// v0->y
	mltu.h %r4, %r5
	ld.w %r4, %alr
	xld.uh %r5, [%r12+0]	;// v0->x
	add %r4, %r5
	xld.w %r10, [%r14+4]	;// param->surface_vbuff
	add %r10, %r4
	xld.w %r11, [%r14+8]	;// param->surface_zbuff
	add %r11, %r4
	;// %r10 = vptr
	;// %r11 = zptr
	;// %r5  = v0->x

	;// 厲DDAZbgAbvB
	xld.uh %r15, [%r13+0]	;// v1->x
	sub %r15, %r5
	xjreq __draw_scanline_wz_color_ret
	;// %r15 = nx

	;// DDAZbgAbvB
	;// (DDA.z)
	xld.uh %r0, [%r12+4]	;// v0->z => cur.z
	xld.uh %r4, [%r13+4]	;// v1->z
	sub %r4, %r0
	xld.w %r13, 1		;// z.v
	xjruge __draw_scanline_wz_color_setup_z
	not %r4, %r4
	xadd %r4, %r4, 1
	xld.w %r13, -1		;// z.v
__draw_scanline_wz_color_setup_z:
	xsll %r4, 16
	ld.w %alr, %r4
	div0u %r15
	div1 %r15		;//  1
	div1 %r15		;//  2
	div1 %r15		;//  3
	div1 %r15		;//  4
	div1 %r15		;//  5
	div1 %r15		;//  6
	div1 %r15		;//  7
	div1 %r15		;//  8
	div1 %r15		;//  9
	div1 %r15		;// 10
	div1 %r15		;// 11
	div1 %r15		;// 12
	div1 %r15		;// 13
	div1 %r15		;// 14
	div1 %r15		;// 15
	div1 %r15		;// 16
	ld.w %r1, %ahr		;// z.n * 2
	add %r1, %r1
	not %r2, %r15		;// z.d
	xadd %r2, %r2, 1
	ld.w %r6, %alr		;// z.u
	mlt.h %r6, %r13
	ld.w %r6, %alr
	;// %r0  = cur.z
	;// %r1  = DDA.z.n * 2
	;// %r2  = DDA.z.d
	;// %r6  = DDA.z.u
	;// %r13 = DDA.z.v

	;// DDA[vB
	ld.w %r7, %r15
	add %r15, %r15
	xld.ub %r12, [%r14+24]	;// param->back_color
__draw_scanline_wz_color_loop:
	;// %r7  = n
	;// %r15 = nx * 2
	;// %r12 = back_color

	;// yrB
	ld.uh %r4, %r0		;// zval
	xsrl %r4, 8
	xld.ub %r5, [%r11]	;// *zptr
	cmp %r4, %r5
	xjrugt __draw_scanline_wz_color_skip
	;// %r4 = zval

	;// eNX`ȂAtFCX̔wiFŕ`܂B
	xld.b [%r10], %r12	;// *vptr
	xld.b [%r11], %r4	;// *zptr
__draw_scanline_wz_color_skip:

	;// obt@|C^i߂܂B
	xadd %r10, %r10, 1
	xadd %r11, %r11, 1

	;// DDAXebvsB
	;// (DDA.z)
	add %r0, %r6		;// cur.z += z.u
	add %r2, %r1		;// z.d += z.n * 2
	xjruge __draw_scanline_wz_color_step_z ;// !C
	add %r0, %r13		;// cur.z += z.v
	sub %r2, %r15		;// z.d -= nx * 2
__draw_scanline_wz_color_step_z:

	xsub %r7, %r7, 1
	xjrne __draw_scanline_wz_color_loop

__draw_scanline_wz_color_ret:
	popn	%r2
	ret
	");
#endif
#endif /*REND_NOASM*/
